package eu.mhsl.craftattack.worldmuseum.commands;

import net.minestom.server.command.builder.Command;
import net.minestom.server.command.builder.arguments.ArgumentType;
import net.minestom.server.coordinate.Pos;
import net.minestom.server.entity.Player;
import java.util.Objects;

public class TeleportCommand extends Command {

    public TeleportCommand() {
        super("tp","teleport");

        var cordinate = ArgumentType.RelativeBlockPosition("Koordinate");
        addSyntax(((sender, context) -> {
            Pos pos = context.get(cordinate).fromSender(sender).asPosition();
            Player player = (Player) sender;
            player.teleport(pos);
        }), cordinate);

        var playerArgument = ArgumentType.Entity("Spieler").onlyPlayers(true);
        addSyntax(((sender, context) -> {
            if (context.get(playerArgument).find(sender).size() == 0) return; //check if player is online
            Player targetPlayer = (Player) context.get(playerArgument).find(sender).get(0);
            Player p = (Player) sender;
            if (!Objects.equals(p.getInstance(), targetPlayer.getInstance()))
                p.setInstance(Objects.requireNonNull(targetPlayer.getInstance()), targetPlayer.getPosition());
            else
                p.teleport(targetPlayer.getPosition());
        }), playerArgument);
    }
}
